---
title: StorageManager.estimate()
slug: Web/API/StorageManager/estimate
tags:
  - API
  - Method
  - Quota
  - Reference
  - Secure context
  - Storage
  - Storage API
  - StorageManager
  - Usage
  - estimate
---
<p>{{securecontext_header}}{{APIRef("Storage")}}</p>

<p><span class="seoSummary">The <strong><code>estimate()</code></strong> method of the {{domxref("StorageManager")}} interface asks the Storage Manager for how much storage the current <a href="/en-US/docs/Glossary/Same-origin_policy">origin</a> takes up (<code>usage</code>), and how much space is available (<code>quota</code>).</span></p>

<p>This method operates asynchronously, so it returns a {{jsxref("Promise")}} which resolves once the information is available. The promise's fulfillment handler is called with a {{domxref("StorageEstimate")}} containing the usage and quota data.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js notranslate">const <var>estimatePromise</var> = <var>StorageManager</var>.estimate();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} that resolves to an object which conforms to the {{domxref('StorageEstimate')}} dictionary. This dictionary contains estimates of how much space is available to the origin in {{domxref("StorageEstimate.quota")}}, as well as how much is currently used in {{domxref("StorageEstimate.usage")}}.</p>

<div class="notecard note">
<p><strong>The returned values are not exact;</strong> between compression, deduplication, and obfuscation for security reasons, they will be imprecise.</p>
</div>

<p>You may find that the <code>quota</code> varies from origin to origin. This variance is based on factors such as:</p>

<ul>
 <li>How often the user visits</li>
 <li>Public site popularity data</li>
 <li>User engagement signals like bookmarking, adding to homescreen, or accepting push notifications</li>
</ul>

<h2 id="Example">Example</h2>

<p>In this example, we obtain the usage estimates and present the percentage of storage capacity currently used to the user.</p>

<h3 id="HTML_content">HTML content</h3>

<pre class="brush: html notranslate">&lt;label&gt;
  You’re currently using about &lt;output id="percent"&gt;
  &lt;/output&gt;% of your available storage.
&lt;/label&gt;
</pre>

<h3 id="JavaScript_content">JavaScript content</h3>

<pre class="brush: js notranslate">navigator.storage.estimate().then(function(estimate) {
  document.getElementById("percent").value =
      (estimate.usage / estimate.quota * 100).toFixed(2);
});
</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Example', 600, 40) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Storage','#dom-storagemanager-estimate','estimate()')}}</td>
   <td>{{Spec2('Storage')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.StorageManager.estimate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Storage API</li>
 <li>{{domxref("Storage")}}, the object returned by {{domxref("Window.localStorage")}}</li>
 <li>{{domxref("StorageManager")}}</li>
 <li>{{domxref("navigator.storage")}}</li>
</ul>
